-- MySQL dump 10.9
--
-- Host: ensdb-1-10    Database: ensembl_web_user_db
-- ------------------------------------------------------
-- Server version	4.1.21-standard

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Table structure for table `group_member`
--

DROP TABLE IF EXISTS `group_member`;
CREATE TABLE `group_member` (
  `group_member_id` int(11) NOT NULL auto_increment,
  `webgroup_id` int(11) NOT NULL default '0',
  `user_id` int(11) NOT NULL default '0',
  `level` enum('member','administrator','superuser') NOT NULL default 'member',
  `status` enum('active','inactive','pending','barred') NOT NULL default 'active',
  `member_status` enum('active','inactive','pending','barred') default 'inactive',
  `created_by` int(11) NOT NULL default '0',
  `modified_by` int(11) NOT NULL default '0',
  `created_at` datetime default NULL,
  `modified_at` datetime default NULL,
  PRIMARY KEY  (`group_member_id`)
) ENGINE=MyISAM AUTO_INCREMENT=260 DEFAULT CHARSET=latin1;

--
-- Table structure for table `group_record`
--

DROP TABLE IF EXISTS `group_record`;
CREATE TABLE `group_record` (
  `group_record_id` int(11) NOT NULL auto_increment,
  `webgroup_id` int(11) default NULL,
  `type` varchar(255) NOT NULL default '',
  `data` text NOT NULL,
  `created_by` int(11) default NULL,
  `modified_by` int(11) default NULL,
  `created_at` datetime default NULL,
  `modified_at` datetime default NULL,
  PRIMARY KEY  (`group_record_id`)
) ENGINE=MyISAM AUTO_INCREMENT=161 DEFAULT CHARSET=latin1;

--
-- Table structure for table `group_record_vega`
--

DROP TABLE IF EXISTS `group_record_vega`;
CREATE TABLE `group_record_vega` (
  `group_record_vega_id` int(11) NOT NULL auto_increment,
  `webgroup_id` int(11) default NULL,
  `type` varchar(255) NOT NULL default '',
  `data` text NOT NULL,
  `created_at` timestamp NOT NULL default '0000-00-00 00:00:00',
  `modified_at` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  PRIMARY KEY  (`group_record_vega_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Table structure for table `session`
--

DROP TABLE IF EXISTS `session`;
CREATE TABLE `session` (
  `last_session_no` int(10) unsigned NOT NULL default '0'
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Table structure for table `session_record`
--

DROP TABLE IF EXISTS `session_record`;
CREATE TABLE `session_record` (
  `session_record_id` int(10) unsigned NOT NULL auto_increment,
  `session_id` int(10) unsigned NOT NULL default '0',
  `type_id` int(10) unsigned NOT NULL default '0',
  `code` varchar(64) NOT NULL default '',
  `data` text NOT NULL,
  `created_at` timestamp NOT NULL default '0000-00-00 00:00:00',
  `modified_at` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  PRIMARY KEY  (`session_record_id`),
  UNIQUE KEY `session_id` (`session_id`,`type_id`,`code`)
) ENGINE=MyISAM AUTO_INCREMENT=30309 DEFAULT CHARSET=latin1;

--
-- Table structure for table `sessions`
--

DROP TABLE IF EXISTS `sessions`;
CREATE TABLE `sessions` (
  `id` varchar(32) NOT NULL default '',
  `a_session` mediumtext NOT NULL,
  `modified_at` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  PRIMARY KEY  (`id`),
  KEY `modified_at` (`modified_at`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Table structure for table `type`
--

DROP TABLE IF EXISTS `type`;
CREATE TABLE `type` (
  `type_id` int(10) unsigned NOT NULL auto_increment,
  `code` varchar(64) NOT NULL default '',
  PRIMARY KEY  (`type_id`),
  UNIQUE KEY `code` (`code`)
) ENGINE=MyISAM AUTO_INCREMENT=3 DEFAULT CHARSET=latin1;

--
-- Table structure for table `user`
--

DROP TABLE IF EXISTS `user`;
CREATE TABLE `user` (
  `user_id` int(11) NOT NULL auto_increment,
  `name` varchar(255) NOT NULL default '',
  `email` varchar(255) NOT NULL default '',
  `salt` varchar(8) NOT NULL default '',
  `password` varchar(64) NOT NULL default '',
  `data` text NOT NULL,
  `organisation` text NOT NULL,
  `status` enum('active','pending','suspended') NOT NULL default 'pending',
  `created_by` int(11) default NULL,
  `modified_by` int(11) default NULL,
  `created_at` timestamp NOT NULL default '0000-00-00 00:00:00',
  `modified_at` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  PRIMARY KEY  (`user_id`)
) ENGINE=MyISAM AUTO_INCREMENT=258 DEFAULT CHARSET=latin1;

--
-- Table structure for table `user_record`
--

DROP TABLE IF EXISTS `user_record`;
CREATE TABLE `user_record` (
  `user_record_id` int(11) NOT NULL auto_increment,
  `user_id` int(11) NOT NULL default '0',
  `type` varchar(255) NOT NULL default '',
  `data` text NOT NULL,
  `created_by` int(11) default NULL,
  `modified_by` int(11) default NULL,
  `created_at` datetime default NULL,
  `modified_at` datetime default NULL,
  PRIMARY KEY  (`user_record_id`)
) ENGINE=MyISAM AUTO_INCREMENT=731 DEFAULT CHARSET=latin1;

--
-- Table structure for table `user_record_vega`
--

DROP TABLE IF EXISTS `user_record_vega`;
CREATE TABLE `user_record_vega` (
  `user_record_vega_id` int(11) NOT NULL auto_increment,
  `user_id` int(11) NOT NULL default '0',
  `type` varchar(255) NOT NULL default '',
  `data` text NOT NULL,
  `created_at` timestamp NOT NULL default '0000-00-00 00:00:00',
  `modified_at` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  PRIMARY KEY  (`user_record_vega_id`)
) ENGINE=MyISAM AUTO_INCREMENT=16 DEFAULT CHARSET=latin1;

--
-- Table structure for table `webgroup`
--

DROP TABLE IF EXISTS `webgroup`;
CREATE TABLE `webgroup` (
  `webgroup_id` int(11) NOT NULL auto_increment,
  `name` varchar(255) NOT NULL default '',
  `blurb` text NOT NULL,
  `data` text NOT NULL,
  `type` enum('open','restricted','private') NOT NULL default 'open',
  `status` enum('active','inactive') NOT NULL default 'active',
  `created_by` int(11) NOT NULL default '0',
  `modified_by` int(11) NOT NULL default '0',
  `created_at` datetime default NULL,
  `modified_at` datetime default NULL,
  PRIMARY KEY  (`webgroup_id`)
) ENGINE=MyISAM AUTO_INCREMENT=137 DEFAULT CHARSET=latin1;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

